***********************************************************************************
* Version 1.0 released on February 25, 2004
* ---------------------------------------------------------------------------------
* Created by Haijun Yang @ University of Michigan, Ann Arbor
* e-mail: yhj@umich.edu, telephone: 734-764-3407
* ---------------------------------------------------------------------------------
* Parameters list in boost.inc file
* ---------------------------------------------------------------------------------
*   nevt - number of total events(maximum) 
*   nvar - number of variables plus 2 for index and s/b classification
*   ntr  - number of classification trees to be constructed
*   node - maxmimum nodes for each classification tree
*   ntrain - number of trainning events for signal and background
*   nsig_train - number of signal events for training
*   nbkgd_train - number of background events for training
*   nc   - number of bins to seperate events in each node
*   nmin - minimum events in one node (leaf)
*   nmax - if number of total events in one node < nmax --> it's a leaf
*   psig0 - if purity*(1.-purity) < psig0 --> it's a leaf
*   iepsilon -> = 1 using epsilon-boosting algorithm, 0 for AdaBoost
*   epsilon - parameter to increase weight of mis-classified events
*   beta - tunning parameter for AdaBoost algorithm(default value=0.5)
*   psig - if signal purity of one leaf > psig -> all events in this leaf are 'signal'
*   psigout - for tree_index output, if psig > psigout, selected as signal
*   irand - 0 for selecting MC sequentially for training, 1 for selecting MC randomly
* --------------------------------------------------------------------------------
* Event inforamtion list
* -----------------------
*   dat_train(nvar,2*ntrain) - events for trainning
*   dat_test(nvar,nevt) - events for test
*   datnode(nvar,ntrain*2) - events information for each node (trainning only)
*   subnode_index(node,ntrain*2) - index of event # in dat for each node
*   wt(2*ntrain) - weight of events
*   ntot - number of total information loaded
*   nevt1 - number of signal events
*   nevt2 - number of background events
*   nleaf - number of leaves of each classification tree
*   nevt_test - number of events for test
*   nsig_test - number of signal events for test
*   nbkgd_test- number of background events for test
*   leaf_index(node/2,2*node)
*                  |   |--> 1-# of cut,2-Ns,3-Ntot,(4-var#1,5-cut1,6-L/R node)
*                  |------> leave #                (7-var#2,8-cut2,9-L/R node) ...
*   tree_index(nevt) -> +1 for 'signal', -1 for 'background' after classification
*   gini_index(node) - gini_index value of each node
***********************************************************************************
      integer nevt,nvar,ntr,node,ntrain,nc,nmin,nmax,iepsilon
      integer nsig_train,nbkgd_train
      integer ngini_index,irand,method_bin
      parameter(nevt=60000,nvar=52+2,ntr=100,node=90) ! leave # = node/2
      parameter(nsig_train=10000,nbkgd_train=10000)
      parameter(ntrain=nsig_train+nbkgd_train,nc=100)
      parameter(nmin=50,nmax=2000,psig0=0.01) ! for node termination(no gini-index)
      parameter(ngini_index=1) ! 1 - yes, 0 - no
      parameter(iepsilon=0,epsilon=0.01,psig=0.5,psigout=0.5)
      parameter(beta=0.5) ! tunning parameter for adaboost
      parameter(irand=1) ! events selected randomly for training if irand=1

      real datnode(nvar,ntrain)
      integer subnode_index(node,ntrain)
      real dat_train(nvar,ntrain)
      real dat_test(nvar,nevt)
      real wt(ntrain),alpha(ntr),alpha_tot
      real gini_index(node)
      common/inputdat/dat_train,dat_test 
      common/ntotevt/ntot,nevt1,nevt2,nevt_test,
     &               nsig_test,nbkgd_test,nleaf
      common/wtdat/wt
      common/alphadat/alpha,alpha_tot
      common/giniinfo/gini_index

      character*80 dfile
      data dfile/'mcsample.example'/

******************************************************************************
